# Name :	Section Finder


require 'sketchup.rb'

module H2SU
module CGImpactReport

class CGImpactreport


	def create_dialog

		@pg_dialog = UI::WebDialog.new("群组与组件诊断报告", true,600,600)
		rbDirPath = File.dirname(File.expand_path(__FILE__))
		rbDirPath.to_s
		html = rbDirPath + "/CG_impact_report.html"
		html = html.to_s	
		@pg_dialog.set_file(html)
		#@pg_dialog.set_position(200,200)
		@pg_dialog.set_size(475,410)


		# -------------------------------------------------------
		# Builds the dialog page from the dialogs initial loading
		# -------------------------------------------------------
		@pg_dialog.add_action_callback("htmlPageBld") { |d, a|
			
			defData = getDefinitionInfo
			
			#escapes the foot(') and inch(") in possible naming
			defData.gsub!("'", %q(\\\'))
			
			js_command = "getDefs('" + defData +"')"
			@pg_dialog.execute_script(js_command)
			#js_command2 = "sortGo()"
			#@pg_dialog.execute_script(js_command2)

		}



		# -------------------------------------------------------
				# Purges Unused Defs
		# -------------------------------------------------------
		@pg_dialog.add_action_callback("purgeUnused") { |d, a|
			purgeAllUnused(a)
		}

		
		# -------------------------------------------------------
		# Selects the instances from dialog
		# -------------------------------------------------------
		@pg_dialog.add_action_callback("selectComp") { |d, a|
			instanceFocus(a)
		}
		
		# -------------------------------------------------------
		# Zoom Selection
		# -------------------------------------------------------
		@pg_dialog.add_action_callback("zoomComp") { |d, a|
			Sketchup.send_action "viewZoomToSelection:"
			
			view = Sketchup.active_model.active_view
			ss= Sketchup.active_model.selection
			view = view.zoom(Sketchup::Selection)
			
			
		}
		
		
		if RUBY_PLATFORM.include?('darwin')
			@pg_dialog.show_modal
		else
			@pg_dialog.show
		end
		@pg_dialog.bring_to_front

		# Initiates the table sorting	
	end



	def purgeAllUnused(a) 
	
			defs =  Sketchup.active_model.definitions
			materials = Sketchup.active_model.materials
			
			before = defs.length
			defs.purge_unused
			after = defs.length
			
			mbefore = materials.length
			materials.purge_unused
			mafter = materials.length
			
			delta = before - after
			mdelta = mbefore - mafter
			
			mssg1 = "没有定义项被清理\n所有组件定义项均在模型中进行使用"
			mssg2 = delta.to_s + " 已清理未使用定义项\n" + mdelta.to_s + " 未使用材质已被清理"
			
			if delta == 0 
				UI.messagebox(mssg1, MB_OK)
				
			else 
				UI.messagebox(mssg2, MB_OK)
				@pg_dialog.execute_script('window.location.href = window.location.href')
			end
			
	end




	def instanceFocus(i)
		
		defs = Sketchup.active_model.definitions
		
		if i == "clear"
			Sketchup.active_model.selection.clear
		else 
			guid = i.to_s
	
			selection = Sketchup.active_model.selection
			#selection.clear
		
			instances = defs[guid].instances
			selection.add(instances)
			
		end
	end

# -------------------------------------------------------
# Generates a string with all comp definition information
# to be used by the web dialog's javascript
# -------------------------------------------------------


	def getDefinitionInfo
		
			
		model = Sketchup.active_model
		defs =  model.definitions
	
		defInfoArray = []
		
		defs.each{|d|
			defInfoRow = []
			guid = d.guid; defInfoRow[0] = guid
			name = d.name; defInfoRow[1] = name
			
			def_ents = d.entities
			#grps = def_ents.grep(Sketchup::Group); gLen = grps.length
			#comps = def_ents.grep(Sketchup::ComponentInstance); cLen = comps.length
			
			entCount = def_ents.length; defInfoRow[2] = entCount
			
			if d.count_used_instances == 0 
				instCount = "0"; defInfoRow[3] = instCount
				total = "Unused Definition"; defInfoRow[4] = total

			else
			instCount = d.count_used_instances; defInfoRow[3] = instCount
			total = entCount * instCount; defInfoRow[4] = total
			end
			
			defInfoArray << defInfoRow

		}


		
		if (defInfoArray.length > 0)
			defData = ""
			
			defInfoArray.each { |x| 

				row = x[0].to_s + "-col-" + x[1] + "-col-" + x[2].to_s + "-col-" + x[3].to_s + "-col-" + x[4].to_s + "-brk-"
				defData << row
	
			}
			
			
			defData.chomp!("-brk-")
			return defData
		end
	end
	
		

# End of Class
end 

unless file_loaded?(__FILE__)
	file_loaded(__FILE__)
		pc_menu= UI.menu("Plugins")
		item = pc_menu.add_item("CG诊断报告"){CGImpactreport.new.create_dialog}
  path = Sketchup.find_support_file("Plugins/h2su_CG_impact_report")
  cgimpactreport_tb = UI::Toolbar.new("CG诊断报告")
  #标注
  cmd = UI::Command.new(("生成诊断报告")) {CGImpactreport.new.create_dialog}
  cmd.small_icon = File.join(path,"icons/cggdbg_24.png")
  cmd.large_icon = File.join(path,"icons/cggdbg_36.png")
  cmd.tooltip = "生成诊断报告"
  cmd.status_bar_text = "生成群组及组件列表，可根据属性进行自定义排序，且可以即时进行选择"
  cgimpactreport_tb.add_item(cmd) 
  #可复制前面一段增加按钮
  cgimpactreport_tb.show
end

#end of modules
end
end


